/* =====================================================================

   LiMo - Liblary
      Sound Manager - Sound 롼

                              Programed by Rero2@fumi (K.Kunikane)
                              E-Mail: rero2@yuumu.rim.or.jp

                              Copyright (C)2000 Kentarou KUNIKANE

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Apr.10.2000  ߷
  May.06.2000  å̿ȥեꥹȤɤ߹ʬ
  May.14.2000  Ĥ
  May.16.2000  BGM  SE μλ(CDĤ)
  May.17.2000  괺 MIDI ʳͽʹФ󤶤

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  lm_sound_init       -- sound manager νprocess fork
  lm_sound_request    -- ޥɤ/׵
  lm_sound_close      -- ɥɥ饤Сνλ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <esd.h>
#include <cdaudio.h>
#include "lm_sound_man.h"

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* --- ɥɥ饤Сȥե饰 */
enum {
  SD_END = 0,
  SD_WAITCOM
};

/* --- Ͽǽ */
#define  SE_MAX    10000
#define  BGM_MAX   256
#define  MIDI_MAX  1

/* --- ɽϥͥ */
#define  SE_CHANNEL_MAX    4
#define  BGM_CHANNEL_MAX   2

/* --- ͥХåե礭(1/4)  ۤȤɤξ4096 */
#define  BUFFER_SIZE  ESD_BUF_SIZE

/* --- ޥɥȡκ */
#define  TOKEN_MAX  32

/* -------------------------------------------------------------
 --- Structure
-------------------------------------------------------------- */

/* --- BGMѥͥǡ */
typedef struct _BGM_CH BGM_CH;
struct _BGM_CH
{
  /* --- եեǥץ (0 ʤ) */
  int  fd;
  /* --- esound  sock */
  int  output;
  /* --- esound ȥ sock */
  int  device;
  /* --- 롼ױե饰 */
  int  loop;
  /* --- 롼׻մᤷ */
  int  loop_fd;
  /* --- ݡ()ե饰 */
  int  pause;
   /* --- WAVEե륹ơ(ƥ쥪Ȥ bit Ȥ) */
  int  wavestat;
  /* --- WAVEե륵ץ󥰥졼 */
  int  waverate;
  /* --- ֥Хåե */
  unsigned char buf[BUFFER_SIZE*4];
  /* --- Хåեݥ */
  int  buf_ptr;
  /* --- ֥Хåեͭǡ */
  int  buf_length;
  /* --- ߤβ */
  int  volume;
  /* --- Ѥäե饰 */
  int  vol_change_flag;
  /* --- եɳϻ */
  struct timeval  tstart;
  /* --- եɻ */
  int  f_time;
  /* --- եɳϻ */
  int  f_start;
  /* --- եɽλ */
  int  f_end;
  /* --- եɥ󥿡 */
  int  f_count;
  /* --- եɸߥե饰 */
  int  f_stop_flag;
};

/* --- SEѥͥǡ */
typedef struct _SE_CH SE_CH;
struct _SE_CH
{
  /* --- եեǥץ (0 ʤ) */
  int  fd;
  /* --- esound  sock */
  int  output;
  /* --- esound ȥ sock */
  int  device;
  /* --- 롼ױե饰 */
  int  loop;
  /* --- 롼׻մᤷ */
  int  loop_fd;
  /* --- WAVEե륹ơ(ƥ쥪Ȥ bit Ȥ) */
  int  wavestat;
  /* --- WAVEե륵ץ󥰥졼 */
  int  waverate;
  /* --- ֥Хåե */
  unsigned char buf[BUFFER_SIZE*4];
  /* --- Хåեݥ */
  int  buf_ptr;
  /* --- ֥Хåեͭǡ */
  int  buf_length;
  /* --- β */
  int  vol_l, vol_r;
  /* --- Ѥäե饰 */
  int  vol_change_flag;
};

/* --- CDѥǡ */
typedef struct _CD_CH CD_CH;
struct _CD_CH
{
  /* --- ߱Υȥå */
  int  track;
  /* --- 롼ױե饰 */
  int  loop;
  /* --- ݡ()ե饰 */
  int  pause;
  /* --- ߤβ */
  int  volume;
  /* --- Ѥäե饰 */
  int  vol_change_flag;
  /* --- եɳϻ */
  struct timeval  tstart;
  /* --- եɻ */
  int  f_time;
  /* --- եɳϻ */
  int  f_start;
  /* --- եɽλ */
  int  f_end;
  /* --- եɥ󥿡 */
  int  f_count;
  /* --- եɸߥե饰 */
  int  f_stop_flag;
};


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* ----- Sound list ɤ߹ */
int  make_list(unsigned char *);
unsigned char *add_file(unsigned char*);

/* ----- Sound request ޥɤβ */
void  request_token(unsigned char*);

/* ----- SOUNDɥ饤С */
void  sound_driver(int);

/* ----- Sound request ޥɤμ¹ */
int   sound_request(void);

/* ----- Sound request ȥɥ饤С */
void  call_se(int, int);
void  call_bgm(int, int);
void  call_cd(int);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ƥץؤϢå */
static int client_sock;

/* --- CDROMؤΥǥХ̾ */
static unsigned char cdrom_name[256];

/* --- libcdrom ؤΥݥ */
static int libcd;

/* --- ESDؤΥå */
static int esd_sock;

/* --- ESDۥ̾ */
static unsigned char esd_name[256];

/* --- ɥեꥹȤΥ */
/* - Ͽɥե͡ο */
static int soundfile_num;
/* - Ͽɥ͡ΥХåեݥ */
static unsigned char *soundfile_buffer;
/* - SEѥե͡ؤΥݥ󥿥ꥹ */
static unsigned char *se_list[SE_MAX];
/* - BGMѥե͡ؤΥݥ󥿥ꥹ */
static unsigned char *bgm_list[BGM_MAX];
/* - MIDIѥե͡ؤΥݥ󥿥ꥹ */
static unsigned char *midi_list[MIDI_MAX];

/* --- ꥯȥޥɤΥȡŸ */
static unsigned char com_token[TOKEN_MAX][256];
static int           com_arg[TOKEN_MAX];
static int           com_ntoken;


/* -------------------------------------------------------------
 --- ͥݻ¤
-------------------------------------------------------------- */

/* - BGMͥ¤ */
BGM_CH  bgmman[BGM_CHANNEL_MAX];

/* - SEͥ¤ */
SE_CH  seman[SE_CHANNEL_MAX];

/* - CDDA¤ */
CD_CH  cdman;


/* -----------------------------------------------------------------------
 --- Interface
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  lm_sound_init       -- sound manager νprocess fork

   sound_list    - ɤΥեꥹ(path դ)
   cd_dev        - CD drive ΥǥХ̾
-------------------------------------------------------------- */
int  lm_sound_init(char *sound_list,
		   char *esd_host,
		   char *cd_dev)
{
  int  sock_fd[2];
  int  tmp_fd;
  pid_t  pid;
  int  i;

  /* --- ɥͥν */
  for(i=0; i<SE_CHANNEL_MAX; i++) {
    seman[i].output = 0;
  }
  for(i=0; i<BGM_CHANNEL_MAX; i++) {
    bgmman[i].output = 0;
  }

  /* --- ɥꥹȤν */
  soundfile_num = 0;
  for(i=0; i<SE_MAX; i++) {
    se_list[i] = 0;
  }
  for(i=0; i<BGM_MAX; i++) {
    bgm_list[i] = 0;
  }
  for(i=0; i<MIDI_MAX; i++) {
    midi_list[i] = 0;
  }
  if (soundfile_buffer != NULL) {
    free(soundfile_buffer);
    soundfile_buffer = NULL;
  }

  /* --- ɥꥹȤν߳ǧ */
  tmp_fd = open(sound_list, O_RDONLY);
  if (tmp_fd < 0) {
    fprintf(stderr, "ERROR sound: Sound list not found. (%s)\n", sound_list);
    return(-1);
  }
  close(tmp_fd);

  /* --- ɥꥹȤɤ߹ */
  if (make_list(sound_list) == 1) {
    fprintf(stderr, "SYNTAX ERROR: in sound list. (%s)\n", sound_list);
    return(-1);
  }

  /* --- CD ǥХν߳ǧ */
  if (cd_dev != NULL) {
    /* -- libcdaudio Υץ/ */
    libcd = cd_init_device(cd_dev);
    if (libcd < 0) {
      fprintf(stderr, "sound: CDROM device not open. (%s)\n", cd_dev);
      cdrom_name[0] = 0;
      libcd = 0;
    }
    else {
      strncpy(cdrom_name, cd_dev, 256);
    }
  }
  else {
    cdrom_name[0] = 0;
    libcd = 0;
  }

  /* --- esd ν߳ǧ */
  if (esd_host != NULL) {
    esd_sock = esd_open_sound(esd_host);
    if (esd_sock <= 0) {
      perror("sound: esd not open.\n");
      esd_sock = 0;
    }
    strncpy(esd_name, esd_host, 256);
  }
  else {
    esd_sock = esd_open_sound(NULL);
    if (esd_sock <= 0) {
      perror("sound: esd not open.\n");
      esd_sock = 0;
    }
    esd_name[0] = 0;
  }

  /* --- ̿ѥåȤκ */
  if (socketpair(AF_LOCAL, SOCK_STREAM, PF_LOCAL, sock_fd) < 0) {
    perror("ERROR sound: socketpair can't make.\n");
    return(-1);
  }

  /* --- ץե */
  pid = fork();
  if (pid < 0) {
    perror("sound fork error.\n");
    close(sock_fd[0]);
    close(sock_fd[1]);
    return(-1);
  }
  else if (pid) {
    /* -- ƥץʤΤǥåfdäƥ꥿ */
    close(sock_fd[1]);
    return(sock_fd[0]);
  }
  /* --- ҥץư */
  close(sock_fd[0]);
#ifdef DEBUG
  fprintf(stderr, "Limo Sound Manager is starting now ..\n");
#endif

  /* --- ɥɥ饤С */
  client_sock = sock_fd[1];
  sound_driver(sock_fd[1]);

  close(sock_fd[1]);
  exit(0);
}



/* -------------------------------------------------------------
  lm_sound_close    -- ɥɥ饤Сνλ

-------------------------------------------------------------- */
void  lm_sound_close(int sock)
{
  lm_sound_request(sock, "E");
  if (soundfile_buffer != NULL) {
    free(soundfile_buffer);
    soundfile_buffer = NULL;
  }
  /* --- esd, libcdaudio Υ */
  if (esd_sock > 0) {
    close(esd_sock);
  }
  if (libcd > 0) {
    cd_stop(libcd);
    cd_finish(libcd);
  }
}


/* -------------------------------------------------------------
  lm_sound_request    -- ޥɤ/׵

   sock          - ɥɥ饤СؤΥå
   command       - ޥʸ
-------------------------------------------------------------- */
int  lm_sound_request(int sock, char *command)
{
  char addcommand[260];
  int  length;

  length = strlen(command);
  if ((length == 0) || (length > 255)) {
    return(-1);
  }
  if (sock != -1) {
    addcommand[0] = ' ';
    addcommand[1] = '\0';
    strncat(addcommand, command, 256);
    length = strlen(addcommand);
    write(sock, addcommand, length);
  }
  return(0);
}




/* -----------------------------------------------------------------------
 --- Subroutine
------------------------------------------------------------------------ */
/* -------------------------------------------------------------
  make_list    -- sound list ɤ߹ߡ
-------------------------------------------------------------- */
int  make_list(unsigned char *soundlist)
{
  FILE *fp;
  int  mode, r, ln;
  unsigned char line[256], tmp[256];
  unsigned int  i, p, listnum;

  /* ---  */
  mode = -1;
  r = 0;
  ln = 0;

  /* --- ե륪ץ */
  fp = fopen(soundlist, "r");
  if (fp == NULL) {
    fprintf(stderr, "ERROR sound: Sound list not found. (%s)\n", soundlist);
    return(0);
  }

  /* --- եɤ߹ */
  while(feof(fp) == 0) {
    fgets(line, 256, fp);
    line[255] = 0;
    ln++;
    /* - ȤΥå */
    if (strcmp(line, "\n") == 0) continue;
    if (line[0] == '#') continue;
    /* - ⡼ɤΥå */
    if ((strncmp(line, "\\SE", 3) == 0) || (strncmp(line, "\\se", 3) == 0)) {
      mode=0;
      continue;
    }
    if ((strncmp(line, "\\BGM", 4) == 0) || (strncmp(line, "\\bgm", 4) == 0)) {
      mode=1;
      continue;
    }
    if ((strncmp(line, "\\MIDI", 5) == 0) || (strncmp(line, "\\midi", 5) == 0)) {
      mode=2;
      continue;
    }
    /* - 餯ե̾ */
    p = (unsigned int)strchr(line, ',');
    p -= (unsigned int)line;
    if (p == 0) {
      fprintf(stderr, "SYNTAX ERROR: Sound list is wrong. line in %d - %s",
	      ln, line);
      fclose(fp);
      return(0);
    }
    strncpy(tmp, line, 256);
    tmp[p] = 0;
    if (sscanf(tmp, "%d", &listnum) == 0) {
      fprintf(stderr, "SYNTAX ERROR: Sound list is wrong. line in %d - %s",
	      ln, line);
      fclose(fp);
      return(0);
    }
    strncpy(tmp, &line[p+1], 256);
    p = (unsigned int)strchr(tmp, '\n');
    if (p != 0) {
      p -= (unsigned int)tmp;
      tmp[p] = 0;
    }
    /* - ̤˥ꥹϿ */
    switch(mode) {
    case 0:
      if (listnum > SE_MAX) {
	fprintf(stderr, "NUMBER FLOW: Sound list is wrong. line in %d - %s",
		ln, line);
	fclose(fp);
	return(0);
      }
      se_list[listnum] = add_file(tmp);
      break;
    case 1:
      if (listnum > BGM_MAX) {
	fprintf(stderr, "NUMBER FLOW: Sound list is wrong. line in %d - %s",
		ln, line);
	fclose(fp);
	return(0);
      }
      bgm_list[listnum] = add_file(tmp);
      break;
    case 2:
      if (listnum > MIDI_MAX) {
	fprintf(stderr, "NUMBER FLOW: Sound list is wrong. line in %d - %s",
		ln, line);
	fclose(fp);
	return(0);
      }
      midi_list[listnum] = add_file(tmp);
      break;
    default:
      break;
    }
  }

  /* --- ޤ */
  fclose(fp);
  return(r);
}

/* ----------------------------
 Хåե˥ե̾ɲ
------------------------------*/
unsigned char *add_file(unsigned char *name)
{
  unsigned char  *ptr, *tp;

  soundfile_num++;
  if (soundfile_num == 0) {
    soundfile_buffer = malloc(256);
    if (soundfile_buffer == 0) {
      return(0);
    }
    ptr = soundfile_buffer;
    strncpy(ptr, name, 256);
  }
  else {
    tp = realloc(soundfile_buffer, soundfile_num*256);
    if (tp == 0) {
      return(0);
    }
    soundfile_buffer = tp;
    ptr = tp + (256 * (soundfile_num - 1));
    strncpy(ptr, name, 256);
  }
}


/* -------------------------------------------------------------
  request_token   -- ꥯȥޥɤΥѥ졼
-------------------------------------------------------------- */
void  request_token(unsigned char* req)
{
  int  token_n, req_length;
  int  i, j, l, n;
  unsigned char c;

  /* -------------------------- */
  /* ȡʬ             */
  /* -------------------------- */
  token_n = 0;
  req_length = strlen(req);
  l = 0;
  n = 0;
  while(l < req_length) {
    c = req[l];
    /* -- ǽζ̵ */
    if ((c == ' ') && (l == 0)) {
      l++;
      continue;
    }
    /* -- ϥѥ졼 */
    if (c == ' ') {
      com_token[token_n][n] = '\0';
      n = 0;
      token_n++;
      /* -- buffer over  */
      if (token_n >= TOKEN_MAX) {
	token_n = TOKEN_MAX;
      }
    }
    else {
      com_token[token_n][n] = c;
      n++;
      /* -- buffer over  */
      if (n >= 255) {
	n = 255;
      }
    }
    l++;
  }
  com_token[token_n][n] = '\0';
  token_n++;
  /* --- ȡο */
  com_ntoken = token_n;

  /* -------------------------- */
  /* ȡοѴ       */
  /* -------------------------- */
  for(i=0; i<TOKEN_MAX; i++) {
    com_arg[i] = -1;
  }
  for(i=0; i<com_ntoken; i++) {
    l = strlen(com_token[i]);
    if ((com_token[i][0] >= '0') && (com_token[i][0] <= '9')) {
      n = 0;
      for(j=0; j<l; j++) {
	if ((com_token[i][j] >= '0') && (com_token[i][j] <= '9')) {
	  n = n * 10 + (int)(com_token[i][j] - '0');
	}
	else {
	  n = -1;
	  break;
	}
      }
      com_arg[i] = n;
    }
    else {
      com_arg[i] = -1;
    }
  }
}


/* -------------------------------------------------------------
  sound_request   -- ꥯȥޥɤβϼ¹
     global ѿ com_token ˤ
-------------------------------------------------------------- */
int  sound_request(void)
{
  char ret_stat[32];
  int  p, i;

  /*------------------------------------------------*/
  /* --- ޥɥȡ롼                 */
  /* ʣΥޥɤޤȤƤǤͤ   */
  /*------------------------------------------------*/
  for(p=0; p<com_ntoken; p++) {
    /* ---------------------------- */
    /* ----- PCM BGM */
    if ((strlen(com_token[p]) == 1) && (com_token[p][0] == 'B')) {
      if (esd_sock == 0) continue;
      /* --  */
      if (strcmp(com_token[p+1], "PLAY") == 0) {
	if ((com_arg[p+2] > -1) && (com_arg[p+2] < BGM_CHANNEL_MAX)
	    && (com_arg[p+3] != -1)) {
	  call_bgm(com_arg[p+2], com_arg[p+3]);
	  p += 3;
	}
      }
      /* --  */
      if (strcmp(com_token[p+1], "STOP") == 0) {
	if ((com_arg[p+2] > -1) && (com_arg[p+2] < BGM_CHANNEL_MAX)){
	  if (bgmman[com_arg[p+2]].fd > 0) {
	    close(bgmman[com_arg[p+2]].fd);
	    close(bgmman[com_arg[p+2]].output);
	    bgmman[com_arg[p+2]].fd = 0;
	    bgmman[com_arg[p+2]].output = 0;
	    p += 2;
	  }
	}
      }
      /* -- ս򤷤ƥݡ򤫤Ե֤ˤ */
      if (strcmp(com_token[p+1], "READY") == 0) {
	if ((com_arg[p+2] > -1) && (com_arg[p+2] < BGM_CHANNEL_MAX)
	    && (com_arg[p+3] != -1)) {
	  call_bgm(com_arg[p+2], com_arg[p+3]);
	  bgmman[com_arg[p+2]].pause = 1;
	  p += 3;
	}
      }
      /* -- ݡ */
      if (strcmp(com_token[p+1], "PAUSE") == 0) {
	if ((com_arg[p+2] > -1) && (com_arg[p+2] < BGM_CHANNEL_MAX)) {
	  bgmman[com_arg[p+2]].pause = 1;
	  p += 2;
	}
      }
      /* -- ݡ */
      if (strcmp(com_token[p+1], "RESUME") == 0) {
	if ((com_arg[p+2] > -1) && (com_arg[p+2] < BGM_CHANNEL_MAX)){
	  bgmman[com_arg[p+2]].pause = 0;
	  p += 2;
	}
      }
      /* -- եɥ󡦥 */
      if (strcmp(com_token[p+1], "FADE") == 0) {
	if ((com_arg[p+2] > -1) && (com_arg[p+2] < BGM_CHANNEL_MAX)) {
	  if ((com_arg[p+4] >= 0) && (com_arg[p+4] < 256) &&
	      (com_arg[p+5] >= 0) && (com_arg[p+5] < 256)) {
	    bgmman[com_arg[p+2]].f_time = com_arg[p+3];
	    bgmman[com_arg[p+2]].f_start = com_arg[p+4];
	    bgmman[com_arg[p+2]].f_end = com_arg[p+5];
	    bgmman[com_arg[p+2]].f_count = com_arg[p+3];
	    /* -- ֤Τ˸߻ */
	    gettimeofday(&bgmman[com_arg[p+2]].tstart, 0);
	    p += 5;
	  }
	}
      }
      /* -- ܥ塼 */
      if (strcmp(com_token[p+1], "VOL") == 0) {
	if ((com_arg[p+2] > -1) && (com_arg[p+2] < BGM_CHANNEL_MAX)) {
	  if ((com_arg[p+3] >= 0) && (com_arg[p+3] < 256)) {
	    bgmman[com_arg[p+2]].volume = com_arg[p+3];
	    bgmman[com_arg[p+2]].vol_change_flag = 1;
	    p += 3;
	  }
	}
      }
      /* -- 롼 */
      if (strcmp(com_token[p+1], "LOOP") == 0) {
	if ((com_arg[p+2] > -1) && (com_arg[p+2] < BGM_CHANNEL_MAX)) {
	  bgmman[com_arg[p+2]].loop = 1;
	  p += 2;
	}
      }
      /* -- 롼ײ */
      if (strcmp(com_token[p+1], "UNLOOP") == 0) {
	if ((com_arg[p+2] > -1) && (com_arg[p+2] < BGM_CHANNEL_MAX)){
	  bgmman[com_arg[p+2]].loop = 0;
	  p += 2;
	}
      }
      /* -- ճϡեɥ */
      if (strcmp(com_token[p+1], "FINPLAY") == 0) {
	if ((com_arg[p+2] > -1) && (com_arg[p+2] < BGM_CHANNEL_MAX)) {
	  if ((com_arg[p+4] > -1) &&
	      (com_arg[p+5] >= 0) && (com_arg[p+5] < 256)) {
	    call_bgm(com_arg[p+2], com_arg[p+4]);
	    bgmman[com_arg[p+2]].f_time = com_arg[p+3];
	    bgmman[com_arg[p+2]].f_start = 0;
	    bgmman[com_arg[p+2]].f_end = com_arg[p+5];
	    bgmman[com_arg[p+2]].f_count = com_arg[p+3];
	    /* -- ֤Τ˸߻ */
	    gettimeofday(&bgmman[com_arg[p+2]].tstart, 0);
	    p += 5;
	  }
	}
      }
      /* -- եɥȡսλ */
      if (strcmp(com_token[p+1], "FOUTEND") == 0) {
	if ((com_arg[p+2] > -1) && (com_arg[p+2] < BGM_CHANNEL_MAX)) {
	  if (com_arg[p+3] > -1) {
	    bgmman[com_arg[p+2]].f_time = com_arg[p+3];
	    bgmman[com_arg[p+2]].f_start = bgmman[com_arg[p+2]].volume;
	    bgmman[com_arg[p+2]].f_end = 0;
	    bgmman[com_arg[p+2]].f_count = com_arg[p+3];
	    bgmman[com_arg[p+2]].f_stop_flag = 1;
	    /* -- ֤Τ˸߻ */
	    gettimeofday(&bgmman[com_arg[p+2]].tstart, 0);
	    p += 3;
	  }
	}
      }
      /* --  */
      if (strcmp(com_token[p+1], "ALLRESET") == 0) {
	for(i=0; i<BGM_CHANNEL_MAX; i++) {
	  if (bgmman[i].fd > 0) {
	    close(bgmman[i].fd);
	    close(bgmman[i].output);
	    bgmman[i].fd = 0;
	    bgmman[i].output = 0;
	    p += 1;
	  }
	}
      }
      /* -- ߤαվ֤ */
      if (strcmp(com_token[p+1], "STAT") == 0) {
	if ((com_arg[p+2] > -1) && (com_arg[p+2] < BGM_CHANNEL_MAX)) {
	  ret_stat[0] = ' ';
	  ret_stat[1] = '\0';
	  if (bgmman[com_arg[p+2]].f_count > 0) {
	    strncat(ret_stat, "C FADE", 32);
	  }
	  else if (bgmman[com_arg[p+2]].pause == 1) {
	    strncat(ret_stat, "C PAUSE", 32);
	  }
	  else if (bgmman[com_arg[p+2]].fd > 0) {
	    strncat(ret_stat, "C PLAY", 32);
	  }
	  else {
	    strncat(ret_stat, "C STOP", 32);
	  }
	  write(client_sock, ret_stat, strlen(ret_stat));
	  p += 2;
	}
      }
    }
    /* ---------------------------- */
    /* ----- PCM SE */
    if ((strlen(com_token[p]) == 1) && (com_token[p][0] == 'S')) {
      if (esd_sock == 0) continue;
      /* --  */
      if (strcmp(com_token[p+1], "ON") == 0) {
	if ((com_arg[p+2] != -1) && (com_arg[p+3] != -1) &&
	    (com_arg[p+4] != -1) && (com_arg[p+5] != -1)) {
	  if ((com_arg[p+2] > -1) && (com_arg[p+2] < SE_CHANNEL_MAX)){
	    call_se(com_arg[p+2], com_arg[p+3]);
	    seman[com_arg[p+2]].vol_l = com_arg[p+4];
	    seman[com_arg[p+2]].vol_r = com_arg[p+5];
	    seman[com_arg[p+2]].vol_change_flag = 1;
	    p += 5;
	  }
	}
      }
      /* --  */
      if (strcmp(com_token[p+1], "OFF") == 0) {
	if ((com_arg[p+2] > -1) && (com_arg[p+2] < SE_CHANNEL_MAX)){
	  if (seman[com_arg[p+2]].fd > 0) {
	    close(seman[com_arg[p+2]].fd);
	    close(seman[com_arg[p+2]].output);
	    seman[com_arg[p+2]].fd = 0;
	    seman[com_arg[p+2]].output = 0;
	    p += 2;
	  }
	}
      }
      /* -- 롼 */
      if (strcmp(com_token[p+1], "LOOP") == 0) {
	if ((com_arg[p+2] > -1) && (com_arg[p+2] < SE_CHANNEL_MAX)){
	  seman[com_arg[p+2]].loop = 1;
	  p += 2;
	}
      }
      /* -- 롼ײ */
      if (strcmp(com_token[p+1], "UNLOOP") == 0) {
	if ((com_arg[p+2] > -1) && (com_arg[p+2] < SE_CHANNEL_MAX)){
	  seman[com_arg[p+2]].loop = 0;
	  p += 2;
	}
      }
      /* --  */
      if (strcmp(com_token[p+1], "ALLRESET") == 0) {
	for(i=0; i<SE_CHANNEL_MAX; i++) {
	  if (seman[i].fd > 0) {
	    close(seman[i].fd);
	    close(seman[i].output);
	    seman[i].fd = 0;
	    seman[i].output = 0;
	    p += 1;
	  }
	}
      }
    }
    /* ----- CD-DA */
    if ((strlen(com_token[p]) == 1) && (com_token[p][0] == 'C')) {
      if (cdrom_name[0] == 0) continue;
      /* --  */
      if (strcmp(com_token[p+1], "PLAY") == 0) {
	if (com_arg[p+2] != -1) {
	  call_cd(com_arg[p+2]);
	  p += 2;
	}
      }
      /* --  */
      if (strcmp(com_token[p+1], "STOP") == 0) {
	cd_stop(libcd);
	cdman.track = 0;
	p += 1;
      }
      /* -- ս򤷤ƥݡ򤫤Ե֤ˤ */
      if (strcmp(com_token[p+1], "READY") == 0) {
	if (com_arg[p+2] != -1) {
	  call_cd(com_arg[p+2]);
	  cd_pause(libcd);
	  cdman.pause = 1;
	  p += 2;
	}
      }
      /* --  */
      if (strcmp(com_token[p+1], "PAUSE") == 0) {
	cd_pause(libcd);
	cdman.pause = 1;
	p += 1;
      }
      /* -- ߲ */
      if (strcmp(com_token[p+1], "RESUME") == 0) {
	cd_resume(libcd);
	cdman.pause = 0;
	p += 1;
      }
      /* -- եɥ󡦥 */
      if (strcmp(com_token[p+1], "FADE") == 0) {
	if ((com_arg[p+3] >= 0) && (com_arg[p+3] < 256) &&
	    (com_arg[p+4] >= 0) && (com_arg[p+4] < 256)) {
	  cdman.f_time = com_arg[p+2];
	  cdman.f_start = com_arg[p+3];
	  cdman.f_end = com_arg[p+4];
	  cdman.f_count = com_arg[p+2];
	  /* -- ֤Τ˸߻ */
	  gettimeofday(&cdman.tstart, 0);
	  p += 4;
	}
      }
      /* -- ճϥꥯȸեɥ */
      if (strcmp(com_token[p+1], "FINPLAY") == 0) {
	if ((com_arg[p+4] >= 0) && (com_arg[p+4] < 256)) {
	  call_cd(com_arg[p+3]);
	  cdman.f_time = com_arg[p+2];
	  cdman.f_start = 0;
	  cdman.f_end = com_arg[p+4];
	  cdman.f_count = com_arg[p+2];
	  /* -- ֤Τ˸߻ */
	  gettimeofday(&cdman.tstart, 0);
	  p += 4;
	}
      }
      /* -- եɥȸսλ */
      if (strcmp(com_token[p+1], "FOUTEND") == 0) {
	cdman.f_time = com_arg[p+2];
	cdman.f_start = cdman.volume;
	cdman.f_end = 0;
	cdman.f_count = com_arg[p+2];
	cdman.f_stop_flag = 1;
	/* -- ֤Τ˸߻ */
	gettimeofday(&cdman.tstart, 0);
	p += 2;
      }
      /* -- 롼 */
      if (strcmp(com_token[p+1], "LOOP") == 0) {
	cdman.loop = 1;
	p += 1;
      }
      /* -- 롼 */
      if (strcmp(com_token[p+1], "UNLOOP") == 0) {
	cdman.loop = 0;
	p += 1;
      }
      /* --  */
      if (strcmp(com_token[p+1], "VOL") == 0) {
	if ((com_arg[p+2] >= 0) && (com_arg[p+2] < 256)) {
	  cdman.volume = com_arg[p+2];
	  cdman.vol_change_flag = 1;
	  p += 2;
	}
      }
      /* -- ߤαվ֤ */
      if (strcmp(com_token[p+1], "STAT") == 0) {
	ret_stat[0] = ' ';
	ret_stat[1] = '\0';
	if (cdman.f_count > 0) {
	  strncat(ret_stat, "C FADE", 32);
	}
	else if (cdman.pause == 1) {
	  strncat(ret_stat, "C PAUSE", 32);
	}
	else if (cdman.track > 0) {
	  strncat(ret_stat, "C PLAY", 32);
	}
	else {
	  strncat(ret_stat, "C STOP", 32);
	}
	write(client_sock, ret_stat, strlen(ret_stat));
	p += 1;
      }
    }
    /* ----- MIDI (future reserved) */
    if ((strlen(com_token[p]) == 1) && (com_token[p][0] == 'M')) {
      continue;
    }
    /* ----- Sound driver STOP */
    if ((strlen(com_token[p]) == 1) && (com_token[p][0] == 'E')) {
      return(SD_END);
    }
  }
  return(SD_WAITCOM);
}


/* -------------------------------------------------------------
  call_se   -- SEꥯ
-------------------------------------------------------------- */
void  call_se(int ch, int n)
{
  esd_info_t  *esdctl;
  esd_player_info_t  *eplayer_list;
  esd_format_t format = 0;
  unsigned char header[44], esdname[16];
  int  d, channel, bits, rate;

  /* --- ϰϥå */
  if ((ch >= SE_CHANNEL_MAX) || (n >= SE_MAX)) {
    return;
  }

  /* --- βäդ */
  if (seman[ch].fd > 0) {
    close(seman[ch].fd);
    seman[ch].fd = 0;
  }
  if (seman[ch].output > 0) {
    close(seman[ch].output);
    seman[ch].output = 0;
  }
  /* --- SEեΥץȥإåβ */
  seman[ch].fd = open(se_list[n], O_RDONLY);
  if (seman[ch].fd == -1) {
    fprintf(stderr, "Sound: SE not open '%s' No.%d\n",
	    se_list[n], n);
    seman[ch].fd = 0;
    return;
  }
  if (read(seman[ch].fd, header, 44) < 44) {
    fprintf(stderr, "Sound: SE WAV file is short. '%s' No.%d\n",
	    se_list[n], n);
    close(seman[ch].fd);
    seman[ch].fd = 0;
    return;
  }
  /* - encode tag */
  d = (int)(header[20] + (header[21] * 0x100));
  if (d != 0x0001) {
    fprintf(stderr, "Sound: SE WAV format is not PCM. '%s' No.%d\n",
	    se_list[n], n);
    close(seman[ch].fd);
    seman[ch].fd = 0;
    return;
  }
  channel = (int)(header[22] + (header[23] * 0x100));
  rate = (int)(header[24] + (header[25] * 0x100) +
	       (header[26] * 0x10000) + (header[27] * 0x1000000));
  bits = (int)(header[34] + (header[35] * 0x100));
  if (((channel != 1) && (channel != 2)) ||
      ((bits != 8) && (bits != 16))) {
    fprintf(stderr, "Sound: SE WAV header is wrong. '%s' No.%d\n",
	    se_list[n], n);
    close(seman[ch].fd);
    seman[ch].fd = 0;
    return;
  }
  /* --- ESDͥΥץ */
  format = ESD_STREAM | ESD_PLAY;
  if (channel == 1) {
    format |= ESD_MONO; 
  }
  else {
    format |= ESD_STEREO; 
  }
  if (channel == 8) {
    format |= ESD_BITS8;
  }
  else {
    format |= ESD_BITS16;
  }
  sprintf(esdname, "SE%08d", n);
  seman[ch].output = esd_play_stream_fallback(format, rate, esd_name, esdname);
  if (seman[ch].output == 0) {
    fprintf(stderr, "Sound: SE ESD open error. \n");
    close(seman[ch].fd);
    seman[ch].fd = 0;
    return;
  }
  /* --- ESD ꥯȤޤǤäԤ */
  usleep(1000*50);
  /* --- ESDȥIDμ */
  esdctl = esd_get_all_info(esd_sock);
  eplayer_list = esdctl->player_list;
  seman[ch].device = 0;
  while(eplayer_list != 0) {
    if (strncmp(eplayer_list->name, esdname, 16) == 0) {
      seman[ch].device = eplayer_list->source_id;
      break;
    }
    if (eplayer_list == eplayer_list->next) {
      eplayer_list = 0;
      eplayer_list = eplayer_list->next;
    }
    else {
      eplayer_list = eplayer_list->next;
    }
  }
  if (seman[ch].device == 0) {
    fprintf(stderr, "Sound: SE ESD control id  error. \n");
    close(seman[ch].fd);
    seman[ch].fd = 0;
    close(seman[ch].output);
    seman[ch].output = 0;
    return;
  }
  /* --- SE(¾) */
  seman[ch].loop_fd = lseek(seman[ch].fd, 0, SEEK_CUR);  /* 44 */
  seman[ch].loop = 0;
  seman[ch].wavestat = format;
  seman[ch].waverate = rate;
  seman[ch].buf_ptr = 0;
  seman[ch].buf_length = 0;
  seman[ch].vol_change_flag = 1;
}

/* -------------------------------------------------------------
  call_bgm   -- BGMꥯ
-------------------------------------------------------------- */
void  call_bgm(int ch, int n)
{
  esd_info_t  *esdctl;
  esd_player_info_t  *eplayer_list;
  esd_format_t format = 0;
  unsigned char header[44], esdname[16];
  int  d, channel, bits, rate;

  /* --- ϰϥå */
  if ((ch >= BGM_CHANNEL_MAX) || (n >= BGM_MAX)) {
    return;
  }


  /* --- βäդ */
  if (bgmman[ch].fd > 0) {
    close(bgmman[ch].fd);
    bgmman[ch].fd = 0;
  }
  if (bgmman[ch].output > 0) {
    close(bgmman[ch].output);
    bgmman[ch].output = 0;
  }
  /* --- BGMեΥץȥإåβ */
  bgmman[ch].fd = open(bgm_list[n], O_RDONLY);
  if (bgmman[ch].fd == -1) {
    fprintf(stderr, "Sound: BGM not open '%s' No.%d\n",
	    se_list[n], n);
    bgmman[ch].fd = 0;
    return;
  }
  if (read(bgmman[ch].fd, header, 44) < 44) {
    fprintf(stderr, "Sound: BGM WAV file is short. '%s' No.%d\n",
	    se_list[n], n);
    close(bgmman[ch].fd);
    bgmman[ch].fd = 0;
    return;
  }
  /* - encode tag */
  d = (int)(header[20] + (header[21] * 0x100));
  if (d != 0x0001) {
    fprintf(stderr, "Sound: BGM WAV format is not PCM. '%s' No.%d\n",
	    se_list[n], n);
    close(bgmman[ch].fd);
    bgmman[ch].fd = 0;
    return;
  }
  channel = (int)(header[22] + (header[23] * 0x100));
  rate = (int)(header[24] + (header[25] * 0x100) +
	       (header[26] * 0x10000) + (header[27] * 0x1000000));
  bits = (int)(header[34] + (header[35] * 0x100));
  if (((channel != 1) && (channel != 2)) ||
      ((bits != 8) && (bits != 16))) {
    fprintf(stderr, "Sound: SE WAV header is wrong. '%s' No.%d\n",
	    se_list[n], n);
    close(bgmman[ch].fd);
    bgmman[ch].fd = 0;
    return;
  }
  /* --- ESDͥΥץ */
  format = ESD_STREAM | ESD_PLAY;
  if (channel == 1) {
    format |= ESD_MONO; 
  }
  else {
    format |= ESD_STEREO; 
  }
  if (channel == 8) {
    format |= ESD_BITS8;
  }
  else {
    format |= ESD_BITS16;
  }
  sprintf(esdname, "BGM%08d", n);
  bgmman[ch].output = esd_play_stream_fallback(format, rate, esd_name, esdname);
  if (bgmman[ch].output == 0) {
    fprintf(stderr, "Sound: SE ESD open error. \n");
    close(bgmman[ch].fd);
    bgmman[ch].fd = 0;
    return;
  }
  /* --- ESD ꥯȤޤǤäԤ */
  usleep(1000*50);
  /* --- ESDȥIDμ */
  esdctl = esd_get_all_info(esd_sock);
  eplayer_list = esdctl->player_list;
  bgmman[ch].device = 0;
  while(eplayer_list != 0) {
    if (strncmp(eplayer_list->name, esdname, 16) == 0) {
      bgmman[ch].device = eplayer_list->source_id;
      break;
    }
    if (eplayer_list == eplayer_list->next) {
      eplayer_list = 0;
      eplayer_list = eplayer_list->next;
    }
    else {
      eplayer_list = eplayer_list->next;
    }
  }
  if (bgmman[ch].device == 0) {
    fprintf(stderr, "Sound: SE ESD control id  error. \n");
    close(bgmman[ch].fd);
    bgmman[ch].fd = 0;
    close(bgmman[ch].output);
    bgmman[ch].output = 0;
    return;
  }
  /* --- BGM(¾) */
  bgmman[ch].loop_fd = lseek(bgmman[ch].fd, 0, SEEK_CUR);  /* 44 */
  bgmman[ch].loop = 0;
  bgmman[ch].pause = 0;
  bgmman[ch].wavestat = format;
  bgmman[ch].waverate = rate;
  bgmman[ch].buf_ptr = 0;
  bgmman[ch].buf_length = 0;
  bgmman[ch].volume = 255;
  bgmman[ch].vol_change_flag = 1;
  bgmman[ch].f_time = 0;
  bgmman[ch].f_start = 0;
  bgmman[ch].f_end = 0;
  bgmman[ch].f_count = 0;
  bgmman[ch].f_stop_flag = 0;
}


/* -------------------------------------------------------------
  call_cd   -- CDꥯ
-------------------------------------------------------------- */
void  call_cd(int n)
{
  if (libcd == 0) return;

  if (cd_play_track(libcd, n, n) == 0) {
    cdman.track = n;
  }
  else {
    cdman.track = 0;
  }
  cdman.loop = 0;
  cdman.pause = 0;
  cdman.volume = 255;
  cdman.vol_change_flag = 1;
  cdman.f_time = 0;
  cdman.f_start = 0;
  cdman.f_end = 0;
  cdman.f_count = 0;
  cdman.f_stop_flag = 0;
}


/* -----------------------------------------------------------------------
 --- Driver
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  sound_driver    -- sound driver ꥯȤμդʬ
-------------------------------------------------------------- */
void  sound_driver(int sock)
{
  int  exec_stat;
  fd_set  readfd, outfd;
  struct timeval tv;
  struct disc_info cdstat;
  struct disc_volume cdvol;
  unsigned char fromsock[256];
  int  wait_input, length;
  int  i, sock_max, tvol;
  long  timer;

  /* --- Ƽ */
  exec_stat = SD_WAITCOM;

  /* ----- ɥɥ饤С롼׺ */
  while(exec_stat != SD_END) {

    /* ----- ꥯȥޥɤΥå */
    tv.tv_sec = 0;
    tv.tv_usec = 0;
    FD_ZERO(&readfd);
    FD_SET(sock, &readfd);
    wait_input = select(sock+1, &readfd, NULL, NULL, &tv);
    /* -------------------------------------------------*/
    /* ----- Ϥäʤ饳ޥɤɤߤߡ   */
    /* -------------------------------------------------*/
    if ((wait_input > 0) && (FD_ISSET(sock, &readfd) == 1)) {
      length = read(sock, fromsock, 256);
      fromsock[length] = 0;
      request_token(fromsock);
#ifdef DEBUG
      printf("sdman> receive %dbyte '%s' token %d\n", length, fromsock, com_ntoken);
#endif
      /* --- ޥɲ */
      exec_stat = sound_request();
    }
    /* -------------------------------------------------*/
    /* ----- BGM̥եɥޥͥ                */
    /* -------------------------------------------------*/
    for(i=0; i<BGM_CHANNEL_MAX; i++) {
      if ((bgmman[i].fd > 0) && (bgmman[i].output > 0) &&
	  (bgmman[i].f_count > 0)) {
	/* --- ߤλ */
	gettimeofday(&tv, 0);
	timer = (tv.tv_sec * 1000) + (tv.tv_usec / 1000); 
	timer -= (bgmman[i].tstart.tv_sec * 1000) +
	  (bgmman[i].tstart.tv_usec / 1000); 
	bgmman[i].f_count = (int)(bgmman[i].f_time - timer);
	if (bgmman[i].f_count < 0) {
	  bgmman[i].f_count = 0;
	}
	/* --- Ĵ */
	tvol = ((bgmman[i].f_start - bgmman[i].f_end) *
		bgmman[i].f_count) / bgmman[i].f_time;
	tvol += bgmman[i].f_end;
	if (bgmman[i].volume != tvol) {
	  bgmman[i].volume = tvol;
	  bgmman[i].vol_change_flag = 1;
	}
	/* --- λ */
	if (bgmman[i].f_count == 0) {
	  bgmman[i].volume = bgmman[i].f_end;
	  bgmman[i].vol_change_flag = 1;
	  /* -- սλե饰ΩäƤ */
	  if (bgmman[i].f_stop_flag == 1) {
	    close(bgmman[i].fd);
	    close(bgmman[i].output);
	    bgmman[i].fd = 0;
	    bgmman[i].output = 0;
	  }
	}
      }
    }
    /* -------------------------------------------------*/
    /* ----- CD̥եɥޥͥ                 */
    /* -------------------------------------------------*/
    if ((libcd > 0) && (cdman.track > 0) && (cdman.f_count > 0)) {
      /* --- ߤλ */
      gettimeofday(&tv, 0);
      timer = (tv.tv_sec * 1000) + (tv.tv_usec / 1000); 
      timer -= (cdman.tstart.tv_sec * 1000) +
	(cdman.tstart.tv_usec / 1000); 
      cdman.f_count = (int)(cdman.f_time - timer);
      if (cdman.f_count < 0) {
	cdman.f_count = 0;
      }
      /* --- Ĵ */
      tvol = ((cdman.f_start - cdman.f_end) *
	      cdman.f_count) / cdman.f_time;
      tvol += cdman.f_end;
      tvol &= 0xfc;
      if (cdman.volume != tvol) {
	cdman.volume = tvol;
	cdman.vol_change_flag = 1;
      }
      /* --- λ */
      if (cdman.f_count == 0) {
	cdman.volume = cdman.f_end;
	cdman.vol_change_flag = 1;
	/* -- սλե饰ΩäƤ */
	if (cdman.f_stop_flag == 1) {
	  cd_stop(libcd);
	  cdman.track = 0;
	}
      }
    }
    /* -------------------------------------------------*/
    /* ----- PCMɲ̥ޥͥ                */
    /* -------------------------------------------------*/
    for(i=0; i<SE_CHANNEL_MAX; i++) {
      if ((seman[i].fd > 0) && (seman[i].output > 0) &&
	  (seman[i].vol_change_flag != 0)) {
	esd_set_stream_pan(esd_sock, seman[i].device,
			   seman[i].vol_l, seman[i].vol_r);
	seman[i].vol_change_flag = 0;
      }
    }
    for(i=0; i<BGM_CHANNEL_MAX; i++) {
      if ((bgmman[i].fd > 0) && (bgmman[i].output > 0) &&
	  (bgmman[i].vol_change_flag != 0)) {
	esd_set_stream_pan(esd_sock, bgmman[i].device,
			   bgmman[i].volume, bgmman[i].volume);
	bgmman[i].vol_change_flag = 0;
      }
    }
    /* -------------------------------------------------*/
    /* ----- CDDḀޥͥ                       */
    /* -------------------------------------------------*/
    if ((libcd != 0) && (cdman.vol_change_flag != 0)) {
      cdvol.vol_front.left = cdvol.vol_front.right =
	cdvol.vol_back.left = cdvol.vol_back.right = cdman.volume;
      cd_set_volume(libcd, cdvol);
      cdman.vol_change_flag = 0;
    }
    /* -------------------------------------------------*/
    /* ----- CDDA롼ץޥͥ                     */
    /* -------------------------------------------------*/
    if ((libcd != 0) && (cdman.track != 0)) {
      cd_stat(libcd, &cdstat);
      if ((cdstat.disc_mode == CDAUDIO_COMPLETED) ||
	  (cdstat.disc_mode == CDAUDIO_NOSTATUS)) {
	if (cdman.loop == 1) {
	  call_cd(cdman.track);
	  cdman.loop = 1;
	}
	else {
	  cdman.track = 0;
	}
      }
    }
    /* -------------------------------------------------*/
    /* ----- PCMɽϥޥͥ                */
    /* -------------------------------------------------*/
    /* ----- ϲǽݡȤΥå */
    tv.tv_sec = 0;
    tv.tv_usec = 1000*100;
    sock_max = 0;
    FD_ZERO(&outfd);
    for(i=0; i<SE_CHANNEL_MAX; i++) {
      if ((seman[i].fd > 0) && (seman[i].output > 0)) {
	FD_SET(seman[i].output, &outfd);
	if (seman[i].output > sock_max) {
	  sock_max = seman[i].output;
	}
      }
    }
    for(i=0; i<BGM_CHANNEL_MAX; i++) {
      if ((bgmman[i].fd > 0) && (bgmman[i].output > 0) &&
	  (bgmman[i].pause == 0)) {
	FD_SET(bgmman[i].output, &outfd);
	if (bgmman[i].output > sock_max) {
	  sock_max = bgmman[i].output;
	}
      }
    }
    /* ---  (̵ưϥȤȤʤ) */
    wait_input = select(sock_max+1, NULL, &outfd, NULL, &tv);
    /* ------- ϲǽʥݡȤФPCMϤ */
    /* ----- SEͥν */
    for(i=0; i<SE_CHANNEL_MAX; i++) {
      if ((seman[i].fd > 0) && (seman[i].output > 0)) {
	if (FD_ISSET(seman[i].output, &outfd) == 1) {
	  /* --- ϲǽ */
	  if (seman[i].buf_ptr == 0) {
	    seman[i].buf_length = read(seman[i].fd,
				       seman[i].buf,
				       BUFFER_SIZE*4);
	  }
	  /* --  */
	  length = seman[i].buf_length - seman[i].buf_ptr;
	  if (length > BUFFER_SIZE) length = BUFFER_SIZE;
	  write(seman[i].output,
		&seman[i].buf[seman[i].buf_ptr],
		length);
	  seman[i].buf_ptr += length;
	  /* -- λȽ */
	  if (seman[i].buf_length == seman[i].buf_ptr) {
	    if (seman[i].buf_length != (BUFFER_SIZE * 4)) {
	      if (seman[i].loop == 1) {
		/* -- 롼׽ */
		lseek(seman[i].fd, seman[i].loop_fd, SEEK_SET);
		seman[i].buf_ptr = 0;
	      }
	      else {
		/* -- SE λ */
		close(seman[i].fd);
		close(seman[i].output);
		seman[i].fd = 0;
		seman[i].output = 0;
	      }
	    }
	    else {
	      /* -- ޤ³ */
	      seman[i].buf_ptr = 0;
	    }
	  }
	}
      }
    }
    /* ----- BGMͥν */
    for(i=0; i<BGM_CHANNEL_MAX; i++) {
      if ((bgmman[i].fd > 0) && (bgmman[i].output > 0)) {
	if (FD_ISSET(bgmman[i].output, &outfd) == 1) {
	  /* --- ϲǽ */
	  if (bgmman[i].buf_ptr == 0) {
	    bgmman[i].buf_length = read(bgmman[i].fd,
				       bgmman[i].buf,
				       BUFFER_SIZE*4);
	  }
	  /* --  */
	  length = bgmman[i].buf_length - bgmman[i].buf_ptr;
	  if (length > BUFFER_SIZE) length = BUFFER_SIZE;
	  write(bgmman[i].output,
		&bgmman[i].buf[bgmman[i].buf_ptr],
		length);
	  bgmman[i].buf_ptr += length;
	  /* -- λȽ */
	  if (bgmman[i].buf_length == bgmman[i].buf_ptr) {
	    if (bgmman[i].buf_length != (BUFFER_SIZE * 4)) {
	      if (bgmman[i].loop == 1) {
		/* -- 롼׽ */
		lseek(bgmman[i].fd, bgmman[i].loop_fd, SEEK_SET);
		bgmman[i].buf_ptr = 0;
	      }
	      else {
		/* -- BGM λ */
		close(bgmman[i].fd);
		close(bgmman[i].output);
		bgmman[i].fd = 0;
		bgmman[i].output = 0;
	      }
	    }
	    else {
	      /* -- ޤ³ */
	      bgmman[i].buf_ptr = 0;
	    }
	  }
	}
      }
    }
  }
}




